## org.apache.lucene.search.spans
Class SpanNearQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.spans.SpanQuery
              org.apache.lucene.search.spans.SpanNearQuery

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  PayloadNearQuery

    public class SpanNearQuery

extends SpanQuery
implements java.lang.Cloneable

Matches spans which are near one another. One can specify slop, the maximum number of intervening unmatched positions, as well as whether matches are required to be in-order.

See Also:
  Serialized Form

Field Summary
`protected java.util.List` `clauses`
`protected java.lang.String` `field`
`protected boolean` `inOrder`
`protected int` `slop`

Constructor Summary
`SpanNearQuery(SpanQuery[] clauses, int slop, boolean inOrder)` Construct a SpanNearQuery.
`SpanNearQuery(SpanQuery[] clauses, int slop, boolean inOrder, boolean collectPayloads)`

Method Summary
`java.lang.Object` `clone()` Returns a clone of this query.
`boolean` `equals(java.lang.Object o)` Returns true iff `o` is equal to this.
`void` `extractTerms(java.util.Set terms)` Expert: adds all terms occurring in this query to the terms set.
`SpanQuery[]` `getClauses()` Return the clauses whose spans are matched.
`java.lang.String` `getField()` Returns the name of the field matched by this query.
`int` `getSlop()` Return the maximum number of intervening unmatched positions permitted.
`Spans` `getSpans(IndexReader reader)` Expert: Returns the matches for this query in an index.
`java.util.Collection` `getTerms()` Deprecated. use extractTerms instead
`int` `hashCode()`
`boolean` `isInOrder()` Return true if matches are required to be in-order.
`Query` `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`java.lang.String` `toString(java.lang.String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

Methods inherited from class org.apache.lucene.search.spans.SpanQuery
`createWeight`

Methods inherited from class org.apache.lucene.search.Query
`combine, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### clauses

    protected java.util.List clauses

### slop

    protected int slop

### inOrder

    protected boolean inOrder

### field

    protected java.lang.String field

Constructor Detail

### SpanNearQuery

    public SpanNearQuery(SpanQuery[] clauses,
                         int slop,
                         boolean inOrder)

  Construct a SpanNearQuery. Matches spans matching a span from each clause, with up to `slop` total unmatched positions between them. * When `inOrder` is true, the spans from each clause must be * ordered as in `clauses`.

### SpanNearQuery

    public SpanNearQuery(SpanQuery[] clauses,
                         int slop,
                         boolean inOrder,
                         boolean collectPayloads)

Method Detail

### getClauses

    public SpanQuery[] getClauses()

  Return the clauses whose spans are matched.

### getSlop

    public int getSlop()

  Return the maximum number of intervening unmatched positions permitted.

### isInOrder

    public boolean isInOrder()

  Return true if matches are required to be in-order.

### getField

    public java.lang.String getField()

  Description copied from class: `SpanQuery`
  Returns the name of the field matched by this query.

  Specified by:
    `getField` in class `SpanQuery`

### getTerms

    public java.util.Collection getTerms()

  Deprecated. use extractTerms instead

  Returns a collection of all terms matched by this query.

  Specified by:
    `getTerms` in class `SpanQuery`
  See Also:
    `extractTerms(Set)`

### extractTerms

    public void extractTerms(java.util.Set terms)

  Description copied from class: `Query`
  Expert: adds all terms occurring in this query to the terms set. Only works if this query is in its `rewritten` form.

  Overrides:
    `extractTerms` in class `Query`

### toString

    public java.lang.String toString(java.lang.String field)

  Description copied from class: `Query`
  Prints a query to a string, with `field` assumed to be the default field and omitted.

  The representation used is one that is supposed to be readable by `QueryParser`. However, there are the following limitations:

  - If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.
  - Some of the more complicated queries (e.g. span queries) don't have a representation that can be parsed by QueryParser.

  Specified by:
    `toString` in class `Query`

### getSpans

    public Spans getSpans(IndexReader reader)
                   throws java.io.IOException

  Description copied from class: `SpanQuery`
  Expert: Returns the matches for this query in an index. Used internally to search for spans.

  Specified by:
    `getSpans` in class `SpanQuery`
  Throws:
    `java.io.IOException`

### rewrite

    public Query rewrite(IndexReader reader)
                  throws java.io.IOException

  Description copied from class: `Query`
  Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `java.io.IOException`

### clone

    public java.lang.Object clone()

  Description copied from class: `Query`
  Returns a clone of this query.

  Overrides:
    `clone` in class `Query`

### equals

    public boolean equals(java.lang.Object o)

  Returns true iff `o` is equal to this.

  Overrides:
    `equals` in class `Query`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Query`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.